<?php

/*
 * Boilerplate
 */

declare(strict_types=1);

namespace Univie\Basisklassifikation;

if (!defined('\\ABSPATH')) {
    exit();
}


/*
 * Sideload a JSKOS file from a URL.
 */
class JSKOSSideloadInput extends AbstractInput
{
    public function process(): mixed
    {
        ini_set('max_execution_time', MAX_EXECUTION_TIME);

        $url = $_POST[$this->name];
        if ($url === null || $url === '') {
            return false;
        }

        $url_parts = parse_url($url);
        if ($url_parts === false) {
            /*FIXME: throw an error.*/
        }

        $response = wp_remote_get($url);
        if (is_wp_error($response)) {
            throw new Errors\WP($response);
        }

        $body = wp_remote_retrieve_body($response);

        $lines = preg_split(
            '/\r*\n/',
            $body,
            flags: PREG_SPLIT_NO_EMPTY
        );

        foreach ($lines as $line) {
            $class = Klasse::from_json($line);
            $class->update_terms(insert: true);
        }

        admin_notify(
            'success',
            __('Loaded %s lines from %s.', 'audiothek'),
            count($lines),
            $url_parts['host']
        );

        return true;
    }
}
