-- Does not fully conform to RFC 4180, but should work.

stringify = pandoc.utils.stringify

do
    -- Shamelessly adapted from
    -- https://www.inf.puc-rio.br/~roberto/lpeg/lpeg.html#CSV
    local field = '"' * lpeg.Cs(((lpeg.P(1) - '"') + lpeg.P '""' / '"') ^ 0) *
                  '"' + lpeg.C((1 - lpeg.S ',\n"' ) ^ 0)
    local record = lpeg.Ct(field * (',' * field) ^ 0) * (lpeg.P '\n' + -1)

    function Reader(input)
        rows = {}
        for line in tostring(input):gmatch '[^\n]+' do
            if not line:match '^[ \t]*$' then
                row = {}
                for i, v in ipairs(lpeg.match(record, line)) do
                    table.insert(row, v)
                end
                table.insert(rows, row)
            end
        end

        return pandoc.Pandoc(
            pandoc.utils.from_simple_table(
                pandoc.SimpleTable(
                    'Basisklassifikation',
                    {pandoc.AlignLeft, pandoc.AlignLeft},
                    {0.15, 0.85},
                    {},
                    rows
                )
            )
        )
    end
end

function Writer(doc, opts)
    output = ""

    doc:walk{
        Table = function (tbl)
            for _, body in ipairs(tbl.bodies) do
                for _, row in ipairs(body.body) do
                    for i, cell in ipairs(row.cells) do
                        if i > 1 then
                            output = output .. ','
                        end
                        output = output
                                 .. '"'
                                 .. stringify(cell.contents):gsub('"', '""')
                                 .. '"'
                    end
                    output = output .. '\r\n'
                end
            end
        end
    }

    return output
end
